<template>
  <div v-if="link" class="sm:flex-row flex flex-col justify-between pt-4 pb-4">
    <a
      :href="link"
      target="_blank"
      rel="noopener"
      class="dark:text-gray-400 hover:underline flex items-center text-sm font-medium text-gray-600"
    >
      Help Us Improve This Page
      <IconExternalLink class="w-4 h-4 ml-1" />
    </a>
    <span class="dark:text-gray-400 flex items-center text-sm font-medium text-gray-600">
      {{ $t('article.updatedAt') }} {{ $d(Date.parse(document.updatedAt), 'long') }}
    </span>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
  props: {
    document: {
      type: Object,
      required: true,
    },
  },
  mounted() {
    this.fetchBlame()
  },
  methods: {
    async fetchBlame() {
      if (!this.settings.gitlabRepoId) {
        return
      }
      console.log(this.gitlabUrls)
      const api = this.gitlabUrls.api

      let fileBlameUrl = `${api.baseUrl}${api.blameUrl}`
      let encodedFilePath = encodeURIComponent(`content${this.document.path}${this.document.extension}`)

      encodedFilePath = encodedFilePath.replace('.', '%2E')
      fileBlameUrl = fileBlameUrl.replace(':file_path', encodedFilePath)
      const options = {}

      if (this.$config.gitlabApiToken) {
        options.headers = { Authorization: `Bearer ${this.$config.gitlabApiToken}` }
      }
      // try {
      //   const result = await fetch(fileBlameUrl, options)
      //   const data = await result.json()
      // } catch (e) {
      //   console.log(e)
      // }
    },
  },
  computed: {
    ...mapGetters(['settings', 'gitlabUrls']),
    link() {
      if (!this.settings.gitlabRepoId || !this.settings.gitlabRepoPath) {
        return
      }
      const { gitlabRepoPath = '', pathToDocsInRepo = '' } = this.settings
      let link = ''
      if (pathToDocsInRepo === '.') {
        link = `https://gitlab.com/${gitlabRepoPath}/-/blob/master/content${this.document.path}${this.document.extension}`
      } else {
        link = `https://gitlab.com/${gitlabRepoPath}/-/blob/master/${pathToDocsInRepo}/content${this.document.path}${this.document.extension}`
      }
      return link
    },
  },
}
</script>
